<?php
//sql server data access class

//common class name for all database types.. 
//thats the first criteria.
//you will notice that the name "SampleDataAccess" is common in the SQL and MySQL class files...
//there won't be a collision as only the proper file will be loaded based on the DB
class SampleDataAccess{
    
    
    
    //member function to return all data.
    //our example is to return all base table entries
    //and ONLY the LAST entered financial data value..

    function GetAllData($orderby='', $dir){
        global $_TABLES;
            //this is a nice example of a sql call that works flawlessly in SQL server, 
            //but not so well in mysql 4.x and lower....
        
        $x=array();
        $sql="select a.id, a.name, a.descr, ";
        $sql.="(select top 1 b.dollarAmount ";
        $sql.="from {$_TABLES['financialData']} b ";
        $sql.="where b.base_id=a.id ";
        $sql.="order by b.dateEntered desc) ";
        $sql.="from ";
        $sql.="{$_TABLES['base']} a ";
        if($orderby!=''){
            $sql .="order by {$orderby} {$dir}";
            }
        
        $res=DB_query($sql);
        $nrows=DB_numRows($res);
        if($nrows>0){
            for($cntr=0;$cntr<$nrows;$cntr++){
                $thisRow= DB_fetchArray($res);
                array_push($x,array($thisRow[0],$thisRow[1],$thisRow[2],$thisRow[3]));
                }
            return $x;
            }
        else{
            return FALSE;
            }        
        }
    
    
    
    //thanks to php.net for this
    function array_push_associative(&$arr) {
      $args = func_get_args();
      foreach ($args as $arg) {
          if (is_array($arg)) {
              foreach ($arg as $key => $value) {
                  @$arr[$key] = $value;
                  $ret++;
              }
          }else{
              @$arr[$arg] = "";
          }
      }
      return $ret;
    } 
        
        
        
        
        
        
        

    }//end class
?>