<?php
//mysql data access class


//common class name for all database types.. 
//thats the first criteria.
//you will notice that the name "SampleDataAccess" is common in the SQL and MySQL class files...
//there won't be a collision as only the proper file will be loaded based on the DB
class SampleDataAccess{

        
    //the call in the mssql class does not work in mysql.. so we have to approximate it in the array push section sadly
    
    function GetAllData($orderby='', $dir){
        global $_TABLES;
            //this is a nice example of a sql call that works flawlessly in SQL server, 
            //but not so well in mysql 4.x and lower....
        $x=array();
                            
        $sql="select a.id, a.name, a.descr ";
        $sql.=" ";
        $sql.="from ";
        $sql.="{$_TABLES['base']} a";
        

        $res=DB_query($sql);
        $nrows=DB_numRows($res);
        if($nrows>0){
            for($cntr=0;$cntr<$nrows;$cntr++){
                $thisRow= DB_fetchArray($res);
                $sql="select b.dollarAmount from {$_TABLES['financialData']} b where b.base_id={$thisRow[0]} order by b.dateEntered desc LIMIT 1";
                $innerRes=DB_query($sql);
                list($dollar)=DB_fetchArray($innerRes);
                array_push($x,array($thisRow[0],$thisRow[1],$thisRow[2],$dollar));
                }
                
            //should this be sorted ?
            if($orderby!=''){
                $this->natsort2d($x, $orderby-1, $dir);
                }
            return $x;
            }
        else{
            return FALSE;
            }        
        }
    
    
        
        
       //thanks to mroach at mroach dot com 
       //as posted on php.net 
       //with a few minor modifications to support reverse sorting...
    function natsort2d( &$arrIn, $index = null, $dir='' )
        {
        
        $arrTemp = array();
        $arrOut = array();
        
        foreach ( $arrIn as $key=>$value ) {
            reset($value);
            $arrTemp[$key] = is_null($index)? current($value): $value[$index];
            }
        natsort($arrTemp); 
        
        
        if($dir=='DESC'){
            $arrTemp = array_reverse($arrTemp, true);
            }
            
        foreach ( $arrTemp as $key=>$value ) {
            $arrOut[$key] = $arrIn[$key];
            }
        
        $arrIn = $arrOut;
        
        }

        
        
    //thanks to php.net for this
    function array_push_associative(&$arr) {
      $args = func_get_args();
      foreach ($args as $arg) {
          if (is_array($arg)) {
              foreach ($arg as $key => $value) {
                  @$arr[$key] = $value;
                  $ret++;
              }
          }else{
              @$arr[$arg] = "";
          }
      }
      return $ret;
    } 
        
        
        
        
        
    }//end class
?>